#!/usr/bin/env python
# vim:ts=8:sw=4

import pygtk
pygtk.require('2.0')
import os
import gtk
import sys

sys.path.append('../backend')
import basedlg
import ap_scan
import dlg_error

class DlgAP(basedlg.BaseDialogClass):
	def set_essid(self, essid):
		self.combo_essid.entry.set_text(essid)
			
	def init_essid(self, essid_list=None):
		if essid_list:
			self.combo_essid.set_popdown_strings(essid_list)
		else:
			self.combo_essid.set_popdown_strings(ap_scan.get_ap_list())

##########
# Callback functions
	def callback_ok_button(self, widget, entry, window):
		print 'ok_button clicked'

		profile = self.entry_profile.get_text()
		interface = self.combo_interface.entry.get_text()
		if interface == 'Nothing':
			print 'setting interface'
		essid = self.combo_essid.entry.get_text()

		if self.radio_flag:
			ipaddr = self.get_ipaddress()
			if ipaddr == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
			
			network = self.get_network()
			if network == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
			netmask = self.get_netmask()
			if netmask == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
	
		dic_data = {}
		dic_data['profile'] = profile
		dic_data['interface'] = interface
		dic_data['essid'] = essid

		if self.get_radio() == 0:
			dic_data['radio'] = 'dhcp'
		else:
			dic_data['radio'] = 'static'
			dic_data['ip'] = ipaddr
			dic_data['network'] = network
			dic_data['netmask'] = netmask

		self.parent.return_dialog_data(dic_data)

		window.destroy()

#		devicename = self.combo_interface.entry.get_text()
#		if devicename:
#			print devicename
#			ifcfg_agent = ifcfg_parser.IfcfgParser(devicename)
#			ifcfg_agent.set_essid(self.combo_essid.entry.get_text())
#			ifcfg_agent.write()
#
#			# XXX check ret
#			ret = net_device_manager.network_restart(devicename)
#			if not ret:
#				error = dlg_error.DlgError('연결이 되지 않았습니다.\n다시 시도해주세요!!', '연결실패')	
#			else:
#				error = dlg_error.DlgError('정상적으로 연결이 되었습니다.', '연결성공')	
#		else:
#			print 'arguments exception'
#		window.destroy()

	def __init__(self, parent_widget, name=None):
		basedlg.BaseDialogClass.__init__(self, parent_widget)
		if name:
			basedlg.BaseDialogClass.set_title(name)

		self.profile_layout.hide()
		self.init_interface()

